package de.jugmuenster.sevendemo;

import java.util.*;
import java.io.*;
import java.util.zip.GZIPInputStream;

public class Anagrams
{
    public static void main(String[] args) throws FileNotFoundException, IOException
    {
//        if (args.length < 2)
//        {
//            System.out.println("Usage: <filename.gz> <minsize>");
//            return;
//        }
//        final String path = args[0];
//        final String sizeArgument = args[1];
        
        //using a larger text corpus you can use this as base options
        //-Xmx750m -XX:+DoEscapeAnalysis -XX:+UseCompressedStrings -XX:+OptimizeStringConcat"
        //and try some other garbage collectors...
        //-XX:+UseG1GC
        //-XX:+UseG1GC -XX:MaxGCPauseMillis=100
        //-XX:+UseG1GC -XX:MaxGCPauseMillis=500
        //-XX:+UseConcMarkSweepGC
        final String path = "german.gz";
        final String sizeArgument = "6";
        
        
        int size = Integer.parseInt(sizeArgument);
        
        long start = System.currentTimeMillis();
        Map<String, List<String>> result = findAnagrams(path);
        long end = System.currentTimeMillis();
        
        System.out.println(String.format("Found %d total anagrams in %s ms.", result.size(), end-start));
        
        printAnagrams(result, size);
        
    }

    public static Map<String, List<String>> findAnagrams(final String path) throws FileNotFoundException, IOException
    {
        Map<String, List<String>> multiMap = new HashMap<String, List<String>>();
        
        BufferedInputStream is = new BufferedInputStream(new GZIPInputStream(Thread.currentThread().getContextClassLoader().getResourceAsStream(path)));
        
        Scanner scanner = new Scanner(is);
        while (scanner.hasNext())
        {
            String word = scanner.next();
            String key = wordToKey(word);
            List<String> wordList = multiMap.get(key);
            if (wordList == null)
            {
                wordList = new ArrayList<String>();
                multiMap.put(key, wordList);
            }
            wordList.add(word);
        }
        scanner.close();
        
        return multiMap;
    }
    
    private static void printAnagrams(Map<String, List<String>> result, int size)
    {
        // Print all permutation groups above size threshold
        for (List<String> wordList : result.values())
        {
            if (wordList.size() == size)
            {
                System.out.println(wordList.size() + ": " + wordList);
            }
        }
    }

    private static String wordToKey(String s)
    {
        char[] a = s.trim().toCharArray();
        Arrays.sort(a);
        return String.valueOf(a);
    }

}