package de.jugmuenster.sevendemo.forkjoin;

import java.util.concurrent.RecursiveTask;

public class FibonacciTask extends RecursiveTask<Long>
{
    private static final long serialVersionUID = 1L;
    private static final int THRESHOLD = 20;
    private FibonacciJob job;
    public long result;

    public FibonacciTask(FibonacciJob job)
    {
        this.job = job;
    }

    @Override
    public Long compute()
    {
        if (job.n < THRESHOLD)
        {
            //fork-join effort higher then benefit
            result = job.solve();
        }
        else
        {
            //fork (divide)
            FibonacciTask task1 = new FibonacciTask(new FibonacciJob(job.n - 1));
            FibonacciTask task2 = new FibonacciTask(new FibonacciJob(job.n - 2));
            task1.fork();
            
            //join (and conquer)
            result = task2.compute() + task1.join();
        }
        return result;
    }
}
